﻿namespace Brizco.Repository.Handlers.Complexes;

public class GetComplexesQueryHandler(IRepositoryWrapper repositoryWrapper)
    : IRequestHandler<GetComplexesQuery, List<ComplexSDto>>
{
    public async Task<List<ComplexSDto>> Handle(GetComplexesQuery request, CancellationToken cancellationToken)
    {
        var tasks = await repositoryWrapper.SetRepository<Complex>().TableNoTracking
            .OrderByDescending(s => s.CreatedAt)
            .Skip(request.Page * 15).Take(15)
            .Select(ComplexMapper.ProjectToSDto)
            .ToListAsync(cancellationToken);

        return tasks;
    }
}