﻿namespace Brizco.Repository.Handlers.Positions;

public class GetPositionQueryHandler(IRepositoryWrapper repositoryWrapper)
    : IRequestHandler<GetPositionQuery, PositionLDto>
{
    public async Task<PositionLDto> Handle(GetPositionQuery request, CancellationToken cancellationToken)
    {
        var shift = await repositoryWrapper.SetRepository<Position>()
            .TableNoTracking
            .Where(s => s.Id == request.Id)
            .Select(PositionMapper.ProjectToLDto)
            .FirstOrDefaultAsync(cancellationToken);

        if (shift == null)
            throw new AppException("Position not found", ApiResultStatusCode.NotFound);
        return shift;
    }
}