﻿namespace Brizco.Repository.Handlers.Tasks;

public class DeleteActivityCommandHandler(IRepositoryWrapper repositoryWrapper)
    : IRequestHandler<DeleteTaskCommand, bool>
{
    public async Task<bool> Handle(DeleteTaskCommand request, CancellationToken cancellationToken)
    {
        var task = await repositoryWrapper.SetRepository<Domain.Entities.Tasks.Task>()
            .TableNoTracking
            .FirstOrDefaultAsync(s => s.Id == request.Id, cancellationToken);
        if (task == null)
            throw new AppException("Task not found", ApiResultStatusCode.NotFound);
        repositoryWrapper.SetRepository<Domain.Entities.Tasks.Task>()
            .Delete(task);

        await repositoryWrapper.SaveChangesAsync(cancellationToken);
        return true;
    }
}